<template>
  <div class="app-container">
    <div style="width: 100%">
      <el-card   class="box-card"  style="height: 60px" >
        <template>
          <div class="container" type="flex" justify="center" style="text-align:center">
            <el-divider><span style="font-size:30px;color:black"><strong>曲轴上线</strong></span></el-divider>
          </div>
        </template>
      </el-card>

      <el-card class="box-card" >
        <el-form :model="from" size="large" :inline="true" label-width="68px" @submit.native.prevent>
          <el-form-item label-width="200" label="曲轴码" :prop="from.scanObject2"  style="align-content: center">
            <input v-model="from.scanObject2"
                   ref="inputdata"
                   style="height: 39px; width: 300px"
                   placeholder="请输入曲轴码"
            />
          </el-form-item>
          <!--          <el-button type="primary" icon="el-icon-refresh" @click="handleQuery">查询</el-button>-->
        </el-form>
      </el-card>
      <el-col :span="24" >
        <el-card class="bottom-card">
          <div slot="header" class="clearfix">
            <i class="el-icon-tickets"></i>
            <span style="font-weight: bold">当前产品信息</span>
          </div>
          <el-descriptions :column="1"  :label-style="{'font-size': '20px'}" border  :content-style="{'min-width': '300px'}">
            <el-descriptions-item label="机型">
              <span>{{queryParams.productSeries}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="箱体码">
              <span>{{queryParams.scanObject1}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="曲轴码">
              <span>{{queryParams.scanObject2}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="结果">
              <span  style="color: #FFFFFF;"  :style="{ backgroundColor: queryParams.tileColor }">{{queryParams.words}}</span>
            </el-descriptions-item>
          </el-descriptions>
          <el-divider></el-divider>
        </el-card>
      </el-col>
    </div>
  </div>
</template>
<script>
import VueQr from 'vue-qr'
import { listTileMatchRules, getTileMatchRules, delTileMatchRules, addTileMatchRules, updateTileMatchRules } from "@/api/main/bs/tileMatchRules/tileMatchRules";
import {listStationConf,getIp} from "@/api/main/sc/stationConf";
import {setBarcode1} from "@/api/main/da/opcuaconfig/opcuaconfig";
import WebSocketReconnect from "@/utils/WebsocketTool";
import {getUrl} from "@/api/main/bs/orderScheduling/orderScheduling";
export default {
  name: "index",
  dicts: ['colour_hex','productseries','axisname','neckname','tilename'],
  components: {
    VueQr,
  },
  data(){
    return{
      scannerFlag: false,
      loading: true,
      locationCode: "OP030",
      locationName: "未配置工位",
      tileMatchKbList: [],
      qrCode: '',
      // 查询参数
      from:{
        pageNum: 1,
        pageSize: 10,
        productSeries: null,
        scanObject1: null,
        //scanObject1: 'P0SQ0-01FZ01-1000;T231224116;DBBBBA',
        scanObject2: "",
        axisName: null,
        neckName: null,
        tileName: null,
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        tileColor: null,
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productSeries: null,
        scanObject1: null,
        // scanObject1: 'P0SQ0-01FZ01-1000;T231224116;DBBBBA',
        scanObject2: null,
        axisName: null,
        neckName: null,
        tileName: null,
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        words:"",
        tileColor: null,
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
    }
  },
  mounted() {
    this.getWebUrl()
    this.setFocus()
    //this.getNowTime()
    this.$refs.inputdata.addEventListener('keydown',this.handleScannerInput)
  },
  beforeDestroy() {
    this.$refs.inputdata.removeEventListener('keydown',this.handleScannerInput)
  },
  methods:{
    getWebUrl(){
      getUrl().then(res=>{
        this.websocketUrl = res+"OP030"
        console.log('websocketUrl：',this.websocketUrl)
        this.initWebSocket()
      })
    },
    initWebSocket: function (){
      //判断当前浏览器是否支持WebSocket
      if ('WebSocket' in window) {
        //连接WebSocket节点
        this.websocket = new WebSocketReconnect(this.websocketUrl);
        //接收到消息的回调方法
        this.websocket.socket.onmessage = (event) => {
          let data = event.data;
          if (data != null && data !== ''){
            this.result = JSON.parse(data);
            console.log('this.result.server_message',this.result.server_message)
            if (this.result.server_message === 'clean'){
              this.$refs.inputdata.focus();
              this.from.scanObject1 = ''
              this.from.scanObjectCopy = ''
              this.from.scanObject2 = ''
              this.from.scanObject3 = ''
              this.from.scanObject4 = ''
              this.from.scanObject5 = ''
              this.queryParams.productSeries = ''
              this.queryParams.scanObject1 = ''
              this.queryParams.scanObjectCopy = ''
              this.queryParams.scanObject2 = ''
              this.queryParams.scanObject3 = ''
              this.queryParams.scanObject4 = ''
              this.queryParams.scanObject5 = ''
              this.queryParams.checkResult = ''
              this.queryParams.checkResultColor = ''
              this.queryParams.tileColor = ''
              this.queryParams.words = ''
            } else if (this.result.server_message.indexOf("*") !== -1){
              const parts1 = this.result.server_message.split("*");
              if (parts1.length >= 2) {
                console.log("44",parts1)
                //const axisValueextracted = parts1[2].substring(3,4);
                this.queryParams.productSeries = parts1[0]
                this.queryParams.scanObject1 = parts1[1]
              }
            }
          }
        }
        //监听窗口关闭事件，当窗口关闭时，主动去关闭websocket连接，防止连接还没断开就关闭窗口，server端会抛异常。
        window.onbeforeunload = function () {
          this.websocket.close()
        }
        //关闭连接
        function closeWebSocket() {
          this.websocket.close()
        }
      } else {
        alert('浏览器不支持webSocket')
      }
    },
    refresh() {
      location.reload();
    },
    setFocus(){
      this.$nextTick(()=>{
        this.$refs.inputdata.focus()
      })
    },
    handleScannerInput(event){
      if (this.scannerFlag){
        this.from.scanObject2 = ''
        this.$refs.inputdata.value = ''
        this.scannerFlag = false
      }
      const input = event.target
      const inputValue = input.value
      //this.from.scanObject2 = inputValue
      if (event.key === 'Enter'){
        this.scannerFlag = true
        this.from.scanObject2 = inputValue
        //console.log('条码：',this.from.scanObject2,this.locationCode)
        if (this.from.scanObject2 !== null && this.from.scanObject2 !== '' && this.locationCode !== '' ) {
          console.log('条码：',this.from.scanObject2,this.locationCode)
          setBarcode1({barcode:this.from.scanObject2,locationCode:this.locationCode}).then(res => {
            if (res.code === 200){
              this.$message({
                message:'操作成功',
                type:'success'
              })
              console.log('返回：',res)
              this.queryParams.scanObject2 = this.from.scanObject2
              this.queryParams.words="扫码成功";
              this.queryParams.tileColor='#00FF00';
            }else {
              this.$message({
                message:res.msg,
                type:'warning'
              })
            }
          })

        }
        //setBarcode({barcode:'1111',locationCode:'555555'})
        // //扫描完成
        // if(this.form.scanObject2 !== null && this.form.scanObject2 !== undefined){
        //   console.log('条码：',this.from.scanObject2,this.locationCode)
        //   //setBarcode(this.form.scanObject2,this.locationCode)
        // }
      }
    },

    /** 搜索按钮操作 */
    handleQuery() {
      this.clear();
      if(this.from.scanObject1 !== null && this.from.scanObject2 !== null
        && this.from.axisName !== null && this.from.axisName !== ""
        && this.from.neckName !== null && this.from.neckName !== ""
        && this.from.tileName !== null && this.from.tileName !== ""
        && this.from.productSeries !== null && this.from.productSeries !== "")
      {
        this.axisValueextracted();
        this.neckValueextracted();
        if(this.queryParams.axisValue !== null && this.queryParams.neckValue !== null){
          this.insetFromToQueryParams();
          this.getList();
        }
        else{
          const h = this.$createElement;
          this.$message({
            message: h('p',null, [
              h('span', null, '警告 '),
              h('i', { style: 'color: black' }, '箱体码或曲轴码输入有误'),
              h()]),
            type: 'error',
            center: true,
            offset:300
          });
        }
      }
      else{
        const h = this.$createElement;
        this.$message({
          message: h('p',null, [
            h('span', null, '警告 '),
            h('i', { style: 'color: black' }, '请填写所有搜索条件'),
            h()]),
          type: 'error',
          center: true,
          offset:300
        });
      }
    },

    // 取箱体码第三段为配瓦值
    axisValueextracted() {
      const parts1 = this.from.scanObject1.split(";");
      if (parts1.length >= 3) {
        //const axisValueextracted = parts1[2].substring(3,4);
        const axisValueextracted = parts1[2];
        return this.queryParams.axisValue= axisValueextracted;

      }
    },

    //取曲轴码第三段为配瓦值
    neckValueextracted() {
      const parts2 = this.from.scanObject2.split(";");
      if (parts2.length >= 3) {
        //const neckValueextracted = parts2[2].substring(3,4);
        const neckValueextracted = parts2[2];
        return this.queryParams.neckValue= neckValueextracted;
      }
    },
    //取配瓦颜色
    getList() {
      let queryParams = {
        productSeries : this.queryParams.productSeries,
        axisName : this.queryParams.axisName,
        neckName : this.queryParams.neckName,
        tileName : this.queryParams.tileName,
        axisValue: this.queryParams.axisValue,
        neckValue: this.queryParams.neckValue,
      }
      console.log(queryParams)
      listTileMatchRules(queryParams).then(response => {
        this.queryParams.tileColor = response.rows[0].tileColor;
      });
    },
    clear(){
      this.queryParams.axisValue=null;
      this.queryParams.neckValue=null;
    },
    insetFromToQueryParams(){
      this.queryParams.productSeries=this.from.productSeries;
      this.queryParams.axisName=this.from.axisName;
      this.queryParams.neckName=this.from.neckName;
      this.queryParams.tileName=this.from.tileName;
      this.queryParams.scanObject1=this.from.scanObject1;
      this.queryParams.scanObject2=this.from.scanObject2;
    }

  },
}
</script>

<style scoped>
::v-deep .el-form-item__label{
  font-size: large;
}
::v-deep .el-card__body{
  padding: 15px 20px 0px 20px;
}
::v-deep .el-input .el-input--medium .el-input--suffix{
  width: 200px;
}
.boxSize{
  height: 60px;
}
.centerText{
  color: black;
  font-weight: bold;
  font-size: 20px;
  display: flex;
  justify-content: center;
  margin-top: 5px
}
</style>
